----------------------------------------------------------------------
-- This file is owned and controlled by Xilinx and must be used     --
-- solely for design, simulation, implementation and creation of    --
-- design files limited to Xilinx devices or technologies. Use      --
-- with non-Xilinx devices or technologies is expressly prohibited  --
-- and immediately terminates your license.                         --
--                                                                  --
-- Xilinx products are not intended for use in life support         --
-- appliances, devices, or systems. Use in such applications are    --
-- expressly prohibited.                                            --
--                                                                  --
-- Copyright (C) 2001, Xilinx, Inc.  All Rights Reserved.           --
----------------------------------------------------------------------

-- You must compile the wrapper file fifo_16_by_32.vhd when simulating
-- the core, fifo_16_by_32. When compiling the wrapper file, be sure to
-- reference the XilinxCoreLib VHDL simulation library. For detailed
-- instructions, please refer to the "Coregen Users Guide".

-- The synopsys directives "translate_off/translate_on" specified
-- below are supported by XST, FPGA Express, Exemplar and Synplicity
-- synthesis tools. Ensure they are correct for your synthesis tool(s).

-- synopsys translate_off
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

Library XilinxCoreLib;
ENTITY fifo_16_by_32 IS
	port (
	clk: IN std_logic;
	sinit: IN std_logic;
	din: IN std_logic_VECTOR(31 downto 0);
	wr_en: IN std_logic;
	rd_en: IN std_logic;
	dout: OUT std_logic_VECTOR(31 downto 0);
	full: OUT std_logic;
	empty: OUT std_logic;
	data_count: OUT std_logic_VECTOR(3 downto 0));
END fifo_16_by_32;

ARCHITECTURE fifo_16_by_32_a OF fifo_16_by_32 IS

component wrapped_fifo_16_by_32
	port (
	clk: IN std_logic;
	sinit: IN std_logic;
	din: IN std_logic_VECTOR(31 downto 0);
	wr_en: IN std_logic;
	rd_en: IN std_logic;
	dout: OUT std_logic_VECTOR(31 downto 0);
	full: OUT std_logic;
	empty: OUT std_logic;
	data_count: OUT std_logic_VECTOR(3 downto 0));
end component;

-- Configuration specification 
	for all : wrapped_fifo_16_by_32 use entity XilinxCoreLib.sync_fifo_v3_0(behavioral)
		generic map(
			c_has_rd_err => 0,
			c_read_data_width => 32,
			c_rd_err_low => 1,
			c_has_wr_ack => 0,
			c_write_data_width => 32,
			c_wr_ack_low => 1,
			c_has_wr_err => 0,
			c_has_dcount => 1,
			c_ports_differ => 0,
			c_rd_ack_low => 1,
			c_memory_type => 1,
			c_write_depth => 16,
			c_has_rd_ack => 0,
			c_read_depth => 16,
			c_dcount_width => 4,
			c_wr_err_low => 1,
			c_enable_rlocs => 0);
BEGIN

U0 : wrapped_fifo_16_by_32
		port map (
			clk => clk,
			sinit => sinit,
			din => din,
			wr_en => wr_en,
			rd_en => rd_en,
			dout => dout,
			full => full,
			empty => empty,
			data_count => data_count);
END fifo_16_by_32_a;

-- synopsys translate_on

